#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

int
main( int argc, char *argv[] )
{
	struct in_addr addr;
	struct hostent *host = NULL;

	printf("before resolving localhost\n");
	addr.s_addr = inet_addr("127.0.0.1");
	host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	printf( "%p\n", host ); // Expecting a non NULL pointer
	printf("before resolving a yahoo address\n");
	addr.s_addr = inet_addr("217.12.3.11");
	host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	printf( "%p\n", host ); // Expecting a non NULL pointer
	printf("before resolving INADDR_BROADCAST\n");
	addr.s_addr = INADDR_BROADCAST;
	host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	printf( "%p\n", host ); // Expecting a NULL pointer
	printf("before resolving INADDR_NONE\n");
	addr.s_addr = INADDR_NONE;
	host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	printf( "%p\n", host ); // Expecting a NULL pointer
	printf("before resolving INADDR_ANY\n");
	addr.s_addr = INADDR_ANY;
	host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	printf( "%p\n", host ); // Expecting a NULL pointer

	return 0;
}
